// Copyright (C) 2017-2021  Nexedi SA and Contributors.
//                          Kirill Smelkov <kirr@nexedi.com>
//
// This program is free software: you can Use, Study, Modify and Redistribute
// it under the terms of the GNU General Public License version 3, or (at your
// option) any later version, as published by the Free Software Foundation.
//
// You can also Link and Combine this program with other software covered by
// the terms of any of the Free Software licenses or any of the Open Source
// Initiative approved licenses and Convey the resulting work. Corresponding
// source of such a combination shall include the source code for all other
// software used.
//
// This program is distributed WITHOUT ANY WARRANTY; without even the implied
// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//
// See COPYING file for full licensing terms.
// See https://www.nexedi.com/licensing for rationale and options.

// Package xio is staging place for go123/xio.
package xio

import (
	"context"
	"errors"
	"io"

	"lab.nexedi.com/kirr/neo/go/internal/log"
//	"lab.nexedi.com/kirr/neo/go/internal/xcontext"
)


// NoEOF returns err, but changes io.EOF -> io.ErrUnexpectedEOF.
func NoEOF(err error) error {
        if err == io.EOF {
                err = io.ErrUnexpectedEOF
        }
        return err
}

// EOFok returns err, but changes io.EOF -> nil.
func EOFok(err error) error {
	if err == io.EOF {
		err = nil
	}
	return err
}

/*
// CloseWhenDone arranges for c to be closed either when ctx is cancelled or
// surrounding function returns.
//
// To work as intended it should be called under defer like this:
//
//	func myfunc(ctx, ...) {
//		defer xio.CloseWhenDone(ctx, c)()
//
// The error - if c.Close() returns with any - is logged.
//
// XXX -> use xcontext.WithCloseOnErrCancel instead?
func CloseWhenDone(ctx context.Context, c io.Closer) func() {
	return xcontext.WhenDone(ctx, func() {
		err := c.Close()
		if err != nil {
			log.Error(ctx, err)
		}
	})
}
*/

// LClose closes c and logs closing error if there was any.
// the error is otherwise ignored
//
// XXX naming? -> CloseOrLog? CloseErrLog? CloseLogErr? CloseAndLogErr?
func LClose(ctx context.Context, c io.Closer) {
	err := c.Close()
	if err != nil {
		log.Error(ctx, err)
	}
}


// WithCloseOnErrCancel closes c on ctx cancel while f is run, or if f returns with an error.
//
// It is usually handy to propagate cancellation to interrupt IO.
//
// Returned error is what f returned, or ctx.Err() if f retrned nil despite that
// ctx was canceled and c closed.
func WithCloseOnErrCancel(ctx context.Context, c io.Closer, f func() error) (err error) {
	closed := false
	fdone := make(chan error)
	defer func() {
		errf, ok := <-fdone // wait for f to complete
		if ok {
			// it was ctx cancel and `return ctx.Err()` vvv
			// -> change return to be what f returned if !nil
			if errf != nil {
				err = errf
			}
		}

		if err != nil {
			if !closed {
				LClose(ctx, c)
			}
		}
	}()

	go func() (err error) {
		defer func() {
			fdone <- err
			close(fdone)
		}()
		return f()
	}()

	select {
	case <-ctx.Done():
		LClose(ctx, c) // interrupt IO
		closed = true
		return ctx.Err()

	case err := <-fdone:
		return err
	}
}

// WithCloseOnRetCancel closes c on ctx cancel while f is run, or when f returns.
//
// It is usually handy to propagate cancellation to interrupt IO.
func WithCloseOnRetCancel(ctx context.Context, c io.Closer, f func() error) error {
	err := WithCloseOnErrCancel(ctx, c, func() error {
		e := f()
		if e == nil {
			e = retOK // force c close
		}
		return e
	})
	if err == retOK {
		err = nil
	}
	return err
}

var retOK = errors.New("ok")
